------------------------------ TEST SCRIPT FLIGHT/MATHS ------------------------
------------------------------ Geoff D -----------------------------------------

------------------------------ GLOBAL VARIABLES --------------------------------
--------------------------------------------------------------------------------

-- KEYCODES
number_1 = 49
number_2 = 50
number_3 = 51

numpad_4 = 100
numpad_5 = 101
numpad_6 = 102
numpad_8 = 104
numpad_2 = 98
numpad_add = 107

-- TRIG/MATH
pi = 3.1415926535897932

-- VELOCITY FUNCTION VARS
velocity_x = 0
velocity_y = 0
velocity_z = 0
angle_roc = 3

hover_flag = 0

IS_GOD = 0
PLAYER_ID = 0
PLAYER_INDEX = 0
PLAYER_CHAR = 0

--****************************************************************************--


------------------------------ INITIALISATION FUNCTION--------------------------
--------------------------------------------------------------------------------

function InitScript()
  -- INSERT ANY INITS HERE
  Wait(10000)
end

--****************************************************************************--

------------------------------ PLAYER EXIST FUNCTIONS --------------------------
--------------------------------------------------------------------------------

-- DOES CHAR POOL EXIST
function WaitForPlayerPoolCreation()
  while (IsPlayerPoolCreated() == 0) do
    Wait(100)
  end
end

-- IS PLAYER CREATED/ACTIVE + GET CHARACTER ID
function WaitForValidPlayer()
  PLAYER_CHAR = 0
  repeat
    CallNative("GET_PLAYER_ID")
	PLAYER_ID = GetIntResult()
	if (PLAYER_ID >= 0) then
	  PushInt(PLAYER_ID)
	  CallNative("CONVERT_INT_TO_PLAYERINDEX")
	  PLAYER_INDEX = GetIntResult()
	  PushInt(PLAYER_INDEX)
      PushVarPtr()
	  CallNative("GET_PLAYER_CHAR")
	  PLAYER_CHAR = GetIntParam(1)
	  if (PLAYER_CHAR <= 0) then
	    Wait(100)
	  end
	end
  until (PLAYER_CHAR > 0)
end

--****************************************************************************--

------------------------------ MATH FUNCTIONS ----------------------------------
--------------------------------------------------------------------------------

-- ABSOLUTE VALUE
function MathAbs(x)

	if x < 0 then
		x = x * -1
	end
	
	return x
	
end
		

-- GET HYPOTENUSE
function MathGetHypotenuse(x,y)

	x = x * x
	y = y * y

	result = MathSqrt((x + y))
	
	return result

end


-- DEGREES TO RADIANS
function MathDegToRad(x)

	result = ((x * pi) / 180)
	
	return result
	
end

-- RADIANS TO DEGREES
function MathRadToDeg(x)

	result = ((x * 180) / pi)
	
	return result
	
end

-- X^Y FUNCTION
function MathPowerOf(x,y)

	z = 1

	for i = 1, y, 1 do
	
		z = z * x

	end
	
	return z

end

-- FACTORIAL FUNCTION
function MathFactorial(x)

	x_temp = x
	x = x - 1
	
	for i = x, 1, -1 do
	
	    x_temp = x_temp * i
	    
	end
	
	return x_temp
	
end

-- SQUARE ROOT FUNCTION
function MathSqrt(x)

	term_1 = 1
	term_2 = (28 * x)
	term_3 = (70 * MathPowerOf(x,2))
	term_4 = (28 * MathPowerOf(x,3))
	term_5 = MathPowerOf(x,4)
	
	term_6 = 8
	term_7 = (1 + x)
	term_8 = (1 + (6 * x) + MathPowerOf(x,2))

 	result = (term_1 + term_2 +  term_3 +  term_4 +  term_5) / (term_6 * term_7 * term_8)
	
	return result

end

-- CORDIC METHOD FOR SIN/COSINE OF BETA (NOT FINISHED)
function MathCordic(beta, n)



end


-- SIN FUNCTION (3 TERM TAYLOR EXPANSION)
function MathSin(x)

	term_1 = x
 	term_2 = (MathPowerOf(x,3) / 6)
	term_3 = (MathPowerOf(x,5) / 120)
	term_4 = (MathPowerOf(x,7) / 5040)

	result = (term_1 - term_2 + term_3 - term_4)

	return result

end

-- COS FUNCTION
function MathCos(x)

 	term_1 = 1
	term_2 = (MathPowerOf(x,2) / 2)
	term_3 = (MathPowerOf(x,4) / 24)
	term_4 = (MathPowerOf(x,6) / 720)

	result = (term_1 - term_2 + term_3 - term_4)

	return result

end

-- ATAN2 IMPLEMENTATION
function MathAtan2(x, y)

	c1 = (pi / 4)
	c2 = 3 * c1
	abs_y = MathAbs(y)
	
	if (x >= 0) then
		r = ((x - abs_y) / (x + abs_y))
		angle = (c1 - (c1 * r))
	else
		r = (x + abs_y) / (abs_y - x)
		angle = (c2 - (c1 * r))
	end
	
	if (y < 0) then
		angle = angle * -1
		return angle
	else
		return angle
	end
	
end

-- INVERSE TAN FUNCTION
function MathAtan(x)

	-- FUNCTION VARS AND CONSTS
	y = 0
    complement = 0
	region = 0
	sign = 0
	tan12thpi = 0.267949192
	tan6thpi = 0.577350269


	-- ARCTAN(-X) = -ARCTAN(X)
	if (x < 0) then
	    x = (x * -1)
		sign = 1
	end
	-- KEEP ARG BETWEEN 0 AND 1
	if (x > 1.0) then
	    x = (1.0 / x)
	    compliment = 1
	end
	-- REDUCE ARG TO BELOW TAN(PI/12)
	if (x > tan12thpi) then
	    x = ((x - tan6thpi)/(1 + (tan6thpi * x)))
	    region = 1
	end

	-- CALL THE ATAN APPROXIMATION FUNCTION
	y = MathAtanS(x)
	
	-- CORRECT FOR REGION
	if (region == 1) then
	    y = y + (pi/6)
	end
	-- CORRECT FOR 1/X IF DONE
	if (complement == 1) then
	    y = (pi/2)-y
	end
	-- CORRECT FOR NEGATIVE ARG IF DONE
	if (sign == 1) then
	    y = (y * -1)
	end

	return y

end

-- SUPPLEMENTARY ATAN ALGORITHM PART
-- ATAN APPROX: ATAN(X) = X(C1+C2*X**2)/(C3+C**2)
function MathAtanS(x)

	-- FUNCTION COEFFS
	c1 = 1.6867629106
	c2 = 0.4378497304
	c3 = 1.6867633134
	
	x2 = x*x
	
	result = (x*(c1+x2*c2)/(c3+x2))
	
	return result
	
end

--****************************************************************************--

--------------------------- PLAYER FLIGHT FUNCS --------------------------------
--------------------------------------------------------------------------------

-- ACCELERATE FORWARD
function FlightAccelerate()

	acceleration = 3

	velocity_x, velocity_y, velocity_z = GetCharVelocity(PLAYER_CHAR)
    SetCharVelocity(PLAYER_CHAR, (velocity_x * acceleration), (velocity_y * acceleration), 1)
    

end

-- DECCELERATE FORWARD
function FlightDeccelerate()

	acceleration = 0.5

	velocity_x, velocity_y, velocity_z = GetCharVelocity(PLAYER_CHAR)
    SetCharVelocity(PLAYER_CHAR, (velocity_x * acceleration), (velocity_y * acceleration), 1)


end

-- LIFT
function FlightLift()

	acceleration = 8

	velocity_x, velocity_y, velocity_z = GetCharVelocity(PLAYER_CHAR)
    SetCharVelocity(PLAYER_CHAR, velocity_x, velocity_y, (velocity_z + acceleration))


end

-- ROTATE FLIGHT RIGHT
function FlightTurnRight()

	velocity_x, velocity_y, velocity_z = GetCharVelocity(PLAYER_CHAR)


	-- ***** WORK OUT WHICH QUADRANT ***** --
	-- ***** AND ADJUST TO QUAD 1    ***** --
	-- RIGHT HAND SIDE OF THE PLANE
	if velocity_x > 0 then
	    -- QUADRANT 1
	    if velocity_y > 0 then

	        quadrant = 1

	    -- QUADRANT 4
        elseif velocity_y < 0 then

            velocity_y = (velocity_y * -1)
            quadrant = 4

        -- ON X-AXIS
        else

	    end

	-- LEFT HAND SIDE OF THE PLANE
	elseif velocity_x < 0 then

	    -- QUADRANT 2
	    if velocity_y > 0 then

			velocity_x = (velocity_x * -1)
			quadrant = 2

	    -- QUADRANT 3
        elseif velocity_y < 0 then

            velocity_x = (velocity_x * -1)
            velocity_y = (velocity_y * -1)
            quadrant = 3

        -- ON X-AXIS
        else
            velocity_x = (velocity_x * -1)
	    end

	-- CENTER OF THE PLANE
	else

	end
	-- ********************************* --


	-- GET THE ANGLE AND ADJUST
	angle = MathAtan2(velocity_x,velocity_y)

    -- GET THE VECTOR
	vector = MathGetHypotenuse(velocity_x, velocity_y)


	-- READJUST FOR ORIGINAL QUADRANT POSITION
	if (quadrant == 1) then

	    angle = angle - MathDegToRad(angle_roc)

	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	elseif (quadrant == 2) then

	    angle = angle + MathDegToRad(angle_roc)

	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	    velocity_x = (velocity_x * -1)

	elseif (quadrant == 3) then

		angle = angle - MathDegToRad(angle_roc)

	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	    velocity_x = (velocity_x * -1)
        velocity_y = (velocity_y * -1)

	elseif (quadrant == 4) then

	    angle = angle + MathDegToRad(angle_roc)

	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	    velocity_y = (velocity_y * -1)

	else

	end

    PrintStrToLog("RIGHT")
	PrintStrToLog(velocity_x)
	PrintStrToLog(velocity_y)
	PrintStrToLog(angle)
	SetCharVelocity(PLAYER_CHAR, velocity_x, velocity_y, velocity_z)

end

-- ROTATE FLIGHT LEFT
function FlightTurnLeft()

	velocity_x, velocity_y, velocity_z = GetCharVelocity(PLAYER_CHAR)


	-- ***** WORK OUT WHICH QUADRANT ***** --
	-- ***** AND ADJUST TO QUAD 1    ***** --
	-- RIGHT HAND SIDE OF THE PLANE
	if velocity_x > 0 then
	    -- QUADRANT 1
	    if velocity_y > 0 then

	        quadrant = 1

	    -- QUADRANT 4
        elseif velocity_y < 0 then

            velocity_y = (velocity_y * -1)
            quadrant = 4

        -- ON X-AXIS
        else

	    end

	-- LEFT HAND SIDE OF THE PLANE
	elseif velocity_x < 0 then

	    -- QUADRANT 2
	    if velocity_y > 0 then

			velocity_x = (velocity_x * -1)
			quadrant = 2

	    -- QUADRANT 3
        elseif velocity_y < 0 then

            velocity_x = (velocity_x * -1)
            velocity_y = (velocity_y * -1)
            quadrant = 3

        -- ON X-AXIS
        else
            velocity_x = (velocity_x * -1)
	    end

	-- CENTER OF THE PLANE
	else

	end
	-- ********************************* --


	-- GET THE ANGLE AND ADJUST
	angle = MathAtan((velocity_y/velocity_x))

    -- GET THE VECTOR
	vector = MathGetHypotenuse(velocity_x, velocity_y)


	-- READJUST FOR ORIGINAL QUADRANT POSITION
	if (quadrant == 1) then
	
	    angle = angle + MathDegToRad(angle_roc)
	    
	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	elseif (quadrant == 2) then
	
	    angle = angle - MathDegToRad(angle_roc)

	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	    velocity_x = (velocity_x * -1)

	elseif (quadrant == 3) then
	
		angle = angle + MathDegToRad(angle_roc)

	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	    velocity_x = (velocity_x * -1)
        velocity_y = (velocity_y * -1)

	elseif (quadrant == 4) then
	
	    angle = angle + MathDegToRad(angle_roc)

	    -- RE-CALCULATE VECTOR COMPONENTS
		velocity_x = vector * MathCos(angle)
		velocity_y = vector * MathSin(angle)
		velocity_z = 0

	    velocity_y = (velocity_y * -1)

	else

	end

	PrintStrToLog("LEFT")
	PrintStrToLog(velocity_x)
	PrintStrToLog(velocity_y)
	PrintStrToLog(angle)
	SetCharVelocity(PLAYER_CHAR, velocity_x, velocity_y, velocity_z)

end
	    

--****************************************************************************--

--------------------------- PLAYER VELOCITY FUNCS ------------------------------
--------------------------------------------------------------------------------

-- GET CHARACTER VELOCITY
function GetCharVelocity(char)

    PushInt(char)
	PushVarPtr()
	PushVarPtr()
	PushVarPtr()
    CallNative("GET_CHAR_VELOCITY")

    return GetFloatParam(1), GetFloatParam(2), GetFloatParam(3)

end

-- SET CHARACTER VELOCITY
function SetCharVelocity(char, velocity_x, velocity_y, velocity_z)

	PushInt(char)
	PushFloat(velocity_x)
	PushFloat(velocity_y)
	PushFloat(velocity_z)
	CallNative("SET_CHAR_VELOCITY")

end

--****************************************************************************--

--------------------------- GIVE WEAPONS / GOD FUNC-----------------------------
--------------------------------------------------------------------------------


-- GIVE <WEAPON NUMBER> WEAPON TO CHARACTER
function GiveWeapon(num)

    PushInt(PLAYER_CHAR)
    PushInt(num)
    PushInt(30000)
    PushInt(0)
    CallNative("GIVE_WEAPON_TO_CHAR")

end

-- TOGGLE GOD MODE + GIVE HELMET IF GOD
function SetPlayerGod()

	if (IS_GOD == 0) then

		PushInt(PLAYER_INDEX)
		PushInt(1)
		CallNative("SET_PLAYER_INVINCIBLE")
		PushInt(PLAYER_INDEX)
		PushInt(1)
		CallNative("SET_PLAYER_NEVER_GETS_TIRED")

		PushInt(PLAYER_CHAR)
		CallNative("GIVE_PED_HELMET")

		IS_GOD = 1

	else

		PushInt(PLAYER_INDEX)
		PushInt(0)
		CallNative("SET_PLAYER_INVINCIBLE")
		PushInt(PLAYER_INDEX)
		PushInt(0)
		CallNative("SET_PLAYER_NEVER_GETS_TIRED")

        PushInt(PLAYER_CHAR)
        PushInt(1)
  		CallNative("REMOVE_PED_HELMET")

		IS_GOD = 0

	end

end

-- HEAL CHARACTER TO FULL HEALTH
function SetPlayerHealth()

	PushInt(PLAYER_CHAR)
	PushInt(200)
	CallNative("SET_CHAR_HEALTH")

end


-- GIVE PLAYER GUNS
function GivePlayerGuns()

 	PushInt(0)
 	CallNative("ENABLE_MAX_AMMO_CAP")

 	GiveWeapon(2)
	GiveWeapon(4)
	GiveWeapon(9)
 	GiveWeapon(10)
 	GiveWeapon(13)
 	GiveWeapon(14)
	GiveWeapon(16)
	GiveWeapon(18)

end

--****************************************************************************--

-------------------------------- MAIN ------------------------------------------
--------------------------------------------------------------------------------

function main()

	InitScript()

	while true do

		WaitForPlayerPoolCreation()
		WaitForValidPlayer()

		-- LIFT
		if (IsKeyPressed(numpad_5) == 1) then

           FlightLift()

   		end

        -- ACCELERATE
        if (IsKeyPressed(numpad_8) == 1) then

		   FlightAccelerate()

     	end

        -- DECCELERATE
        if (IsKeyPressed(numpad_2) == 1) then
        
           FlightDeccelerate()

   		end
   		
   		-- FLY LEFT
   		if (IsKeyPressed(numpad_4) == 1) then

           FlightTurnLeft()

   		end
   		
   		-- FLY RIGHT
   		if (IsKeyPressed(numpad_6) == 1) then

           FlightTurnRight()

   		end
   		
   		-- GIVE GODMODE
   		if (IsKeyPressed(number_1) == 1) then

           SetPlayerGod()

   		end
   		
   		-- FLY RIGHT
   		if (IsKeyPressed(number_2) == 1) then

           GivePlayerGuns()

   		end
   		
   		-- FLY RIGHT
   		if (IsKeyPressed(number_3) == 1) then

           SetPlayerHealth()

   		end




        Wait(100)
	end
end

--****************************************************************************--

-------------------------------- START -----------------------------------------
--------------------------------------------------------------------------------

main();

--****************************************************************************--